/*
 * This file is generated by jOOQ.
 */
package nu.studer.sample.tables.records;


import java.sql.Date;
import java.util.UUID;

import javax.annotation.processing.Generated;

import nu.studer.sample.tables.Task;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.15.1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TaskRecord extends UpdatableRecordImpl<TaskRecord> implements Record8<UUID, UUID, String, Date, Date, Date, Double, UUID> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>selfbooster.task.uuid</code>.
     */
    public TaskRecord setUuid(UUID value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.uuid</code>.
     */
    public UUID getUuid() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>selfbooster.task.parent_task_uuid</code>. uuid
     * родительской задачи
     */
    public TaskRecord setParentTaskUuid(UUID value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.parent_task_uuid</code>. uuid
     * родительской задачи
     */
    public UUID getParentTaskUuid() {
        return (UUID) get(1);
    }

    /**
     * Setter for <code>selfbooster.task.description</code>.
     */
    public TaskRecord setDescription(String value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.description</code>.
     */
    public String getDescription() {
        return (String) get(2);
    }

    /**
     * Setter for <code>selfbooster.task.created_at</code>.
     */
    public TaskRecord setCreatedAt(Date value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.created_at</code>.
     */
    public Date getCreatedAt() {
        return (Date) get(3);
    }

    /**
     * Setter for <code>selfbooster.task.desired_at</code>.
     */
    public TaskRecord setDesiredAt(Date value) {
        set(4, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.desired_at</code>.
     */
    public Date getDesiredAt() {
        return (Date) get(4);
    }

    /**
     * Setter for <code>selfbooster.task.due_at</code>.
     */
    public TaskRecord setDueAt(Date value) {
        set(5, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.due_at</code>.
     */
    public Date getDueAt() {
        return (Date) get(5);
    }

    /**
     * Setter for <code>selfbooster.task.percent</code>. процент выполнения
     */
    public TaskRecord setPercent(Double value) {
        set(6, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.percent</code>. процент выполнения
     */
    public Double getPercent() {
        return (Double) get(6);
    }

    /**
     * Setter for <code>selfbooster.task.purpose_uuid</code>.
     */
    public TaskRecord setPurposeUuid(UUID value) {
        set(7, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.task.purpose_uuid</code>.
     */
    public UUID getPurposeUuid() {
        return (UUID) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record8 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row8<UUID, UUID, String, Date, Date, Date, Double, UUID> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    @Override
    public Row8<UUID, UUID, String, Date, Date, Date, Double, UUID> valuesRow() {
        return (Row8) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return Task.TASK.UUID;
    }

    @Override
    public Field<UUID> field2() {
        return Task.TASK.PARENT_TASK_UUID;
    }

    @Override
    public Field<String> field3() {
        return Task.TASK.DESCRIPTION;
    }

    @Override
    public Field<Date> field4() {
        return Task.TASK.CREATED_AT;
    }

    @Override
    public Field<Date> field5() {
        return Task.TASK.DESIRED_AT;
    }

    @Override
    public Field<Date> field6() {
        return Task.TASK.DUE_AT;
    }

    @Override
    public Field<Double> field7() {
        return Task.TASK.PERCENT;
    }

    @Override
    public Field<UUID> field8() {
        return Task.TASK.PURPOSE_UUID;
    }

    @Override
    public UUID component1() {
        return getUuid();
    }

    @Override
    public UUID component2() {
        return getParentTaskUuid();
    }

    @Override
    public String component3() {
        return getDescription();
    }

    @Override
    public Date component4() {
        return getCreatedAt();
    }

    @Override
    public Date component5() {
        return getDesiredAt();
    }

    @Override
    public Date component6() {
        return getDueAt();
    }

    @Override
    public Double component7() {
        return getPercent();
    }

    @Override
    public UUID component8() {
        return getPurposeUuid();
    }

    @Override
    public UUID value1() {
        return getUuid();
    }

    @Override
    public UUID value2() {
        return getParentTaskUuid();
    }

    @Override
    public String value3() {
        return getDescription();
    }

    @Override
    public Date value4() {
        return getCreatedAt();
    }

    @Override
    public Date value5() {
        return getDesiredAt();
    }

    @Override
    public Date value6() {
        return getDueAt();
    }

    @Override
    public Double value7() {
        return getPercent();
    }

    @Override
    public UUID value8() {
        return getPurposeUuid();
    }

    @Override
    public TaskRecord value1(UUID value) {
        setUuid(value);
        return this;
    }

    @Override
    public TaskRecord value2(UUID value) {
        setParentTaskUuid(value);
        return this;
    }

    @Override
    public TaskRecord value3(String value) {
        setDescription(value);
        return this;
    }

    @Override
    public TaskRecord value4(Date value) {
        setCreatedAt(value);
        return this;
    }

    @Override
    public TaskRecord value5(Date value) {
        setDesiredAt(value);
        return this;
    }

    @Override
    public TaskRecord value6(Date value) {
        setDueAt(value);
        return this;
    }

    @Override
    public TaskRecord value7(Double value) {
        setPercent(value);
        return this;
    }

    @Override
    public TaskRecord value8(UUID value) {
        setPurposeUuid(value);
        return this;
    }

    @Override
    public TaskRecord values(UUID value1, UUID value2, String value3, Date value4, Date value5, Date value6, Double value7, UUID value8) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TaskRecord
     */
    public TaskRecord() {
        super(Task.TASK);
    }

    /**
     * Create a detached, initialised TaskRecord
     */
    public TaskRecord(UUID uuid, UUID parentTaskUuid, String description, Date createdAt, Date desiredAt, Date dueAt, Double percent, UUID purposeUuid) {
        super(Task.TASK);

        setUuid(uuid);
        setParentTaskUuid(parentTaskUuid);
        setDescription(description);
        setCreatedAt(createdAt);
        setDesiredAt(desiredAt);
        setDueAt(dueAt);
        setPercent(percent);
        setPurposeUuid(purposeUuid);
    }

    /**
     * Create a detached, initialised TaskRecord
     */
    public TaskRecord(nu.studer.sample.tables.pojos.Task value) {
        super(Task.TASK);

        if (value != null) {
            setUuid(value.getUuid());
            setParentTaskUuid(value.getParentTaskUuid());
            setDescription(value.getDescription());
            setCreatedAt(value.getCreatedAt());
            setDesiredAt(value.getDesiredAt());
            setDueAt(value.getDueAt());
            setPercent(value.getPercent());
            setPurposeUuid(value.getPurposeUuid());
        }
    }
}
